module.exports = function (grunt) {
    'use strict';
    var pkg = grunt.file.readJSON('package.json'),
        srcFiles = [
            'Gruntfile.js',
            'lib/*.js',
            'lib/**/*.js'
        ];

    // Project configuration.
    grunt.initConfig({
        jshint: {
            all: srcFiles,
            options: pkg.jshintConfig
        },
        jscs: {
            src: srcFiles,
            options: grunt.file.readJSON('.jscs.json'),
        }
    });

    grunt.loadNpmTasks('grunt-jscs');
    grunt.loadNpmTasks('grunt-contrib-jshint');
    grunt.loadNpmTasks('grunt-deployinator');

    grunt.registerTask('check', ['jshint', 'jscs']);
    grunt.registerTask('deploy', ['check', 'tagRelease']);

    grunt.registerTask('default', ['check']);
};
